使用反射机制调用,如何捕获自定义异常?

代码如下:

[code="java"]class A {
public void a() throw SelfException{//自定义异常

 try{
    //do something
 }catch (Exception e){
    throw new SelfException(e);
 }

}
}[/code]

我的客户端通过反射机制调用A,但是发现do something出错的时候,无法捕获到SelfException。

我跟踪了一下,客户端捕获了java.lang.reflect.InvocationTargetException,然后打印异常堆栈,确实可以看到最实际的原因(可能是数据库出错等底层原因),但这都不是我想要的,我期望客户端够捕获到SelfException异常(因为这里我做了一些特殊处理)。

请问这是何缘故?可以如何解决这个问题?

我在网上找了一下,.net领域里面也有InvocationTargetException异常,同样是使用发射机制调用时可能抛出。但是.net领域还有一个innerException可以获取到用户自定义的异常。但java我不知道可以怎么处理。

求赐教。多谢了。
[b]问题补充:[/b]
谢谢lovewhzlq。

但是这还不是我要的答案。

我想知道到底有没什么方法可以获取到SelfException?

因为我们目前的系统的异常设计,是有一种特别针对客户端的UI异常,这种异常被客户端获取之后,将最终转换成提示信息。但是我现在用了反射就获取不了这种异常了。

oo

3个回答

这个肯定是不直接能扑获你自定义的异常的。
原因很简单。
你的反射调用失败了。 说白了,就是你将dosomething处的异常封装成自定义的。
但是反射的地方的代码,还是会对你的自定义异常再一次封装成反射调用失败的异常。
就像如下这样:
[code="java"]
try{
try{

//do something

}catch (Exception e){

throw new SelfException(e);

}

}catch(Exception e){
new InvocationTargetException(e)
}
[/code]
在这样的情况下,你怎么可能扑获得到你的自定义异常?
在正常调用的情况下,肯定是可以扑获到自定义的异常。

你得到InvocationTargetException异常后,

调用
Throwable getCause()
返回此异常的原因(抛出的目标异常,可能为 null)。
Throwable getTargetException()
获得抛出的目标异常。

设置断点,debug一下.

Csdn user default icon
上传中...
上传图片
插入图片
抄袭、复制答案,以达到刷声望分或其他目的的行为,在CSDN问答是严格禁止的,一经发现立刻封号。是时候展现真正的技术了!
立即提问
相关内容推荐